#!/bin/sh
#
# $1 executable
# $2 test to run
#
if [ $1 = ./coverage ] ; then
  CMD=$1
else
  CMD="./limit-big $1" 
fi 
export KEY="blahblah"

rm -rf save_test2.txt save_test3.txt save_test4.txt test1.out \
    test2.txt test2.txt.cpt test3.txt test3.txt.cpt test4-sub.txt \
    test4.txt test4.txt.cpt

cp test2.out test2.txt
cp test3.out test3.txt
cp test2.out test4.txt
cp test2.txt save_test2.txt
cp test3.txt save_test3.txt
cp test4.txt save_test4.txt

case $2 in
    p1) $CMD -help > test1.out
        diff output.t1 test1.out && exit 0 ;;

    p2) $CMD -e -E KEY test2.txt && exit 0 ;;

    p3) $CMD -d -E KEY test2.txt.cpt
        diff test2.txt save_test2.txt && exit 0 ;;

    p4) cat test2.txt test2.txt > test4-sub.txt
        rm -f test4-sub.txt.cpt
        ccrypt -e -E KEY test4-sub.txt
        mv test4-sub.txt.cpt test4.cpt
        cp test2.out test4.txt
        rm yes.txt
        echo "yes\n" > yes.txt
        exec 3<> yes.txt
        $CMD -e -E KEY test4.txt <&3 && exit 0 ;;

    p5) exec 3>&-
        $CMD -d -E KEY test4.txt.cpt
        diff test4.txt save_test4.txt && exit 0 ;;

    p7) rm no.txt
        rm test4.txt.cpt
        cat test2.txt test2.txt > test4-sub.txt
        cp test4-sub.txt test4-sub-ref.txt
        echo "no\n" > no.txt
        rm test4-sub.txt.cpt
        ccrypt -e -E KEY test4-sub.txt
        mv test4-sub.txt.cpt test4.txt.cpt
        cp test2.txt test4.txt
        exec 4<> no.txt
        $CMD -e -E KEY test4.txt <&4 && exit 0 ;;

    p6) rm no.txt
        rm test4.txt.cpt
        cat test2.txt test2.txt > test4-sub.txt
        cp test4-sub.txt test4-sub-ref.txt
        echo "\n\n" > no.txt
        rm test4-sub.txt.cpt
        ccrypt -e -E KEY test4-sub.txt
        mv test4-sub.txt.cpt test4.txt.cpt
        cp test2.txt test4.txt
        # exec 4<> no.txt
        # $CMD -e -E KEY test4.txt
        cp test4.txt.cpt test4-sub.txt.cpt
        exec 4<> no.txt
        exec 4>&-
        $CMD -d -E KEY test4-sub.txt.cpt
        diff test4-sub.txt test4-sub-ref.txt && exit 0 ;;

    n1) rm -rf core.* use_test6.*
        cp test6.txt use_test6.txt
        rm -f use_test6.txt.cpt
        ccrypt -e -E KEY use_test6.txt
        cp test6.txt use_test6.txt
        (./limit $1 -e -E KEY use_test6.txt < /dev/null)
        if [ $? -eq 139 ] ; then exit 1; else exit 0; fi ;;

esac
exit 1
